/****
*
*
*     (c) 1999-2000 Manos Aspradakis, Greece
*     eMail : maspr@otenet.gr
*
*
*     Win98.prg
*
*     Windows 3.xx, 95xx, 98xx identification/utility functions
*
*     IsNetwork()         Return if running under a network
*
*     IsMsWin()           Return if running under windows
*     MsWinVersion()      Return array of windows information:
*                         aRet[1]  Full Version
*                         aRet[2]  Major version
*                         aRet[3]  Minor version
*                         aRet[4]  Enhanced mode info:
*                                  02 - Standard mode
*                                  03 - Enhanced mode
*
*     SetWinAppName()     Sets the name that appears on the caption of
*                         a DOS box (Right) in W95
*     SetWinVMName()      Sets the virtual machine name of a DOS box (Left)
*                         in W95
*     GetWinAppName()     Returns the name that appears on the caption of
*                         a DOS box in W95
*     GetWinVMName()      Returns the virtual machine name of a DOS box
*     GetWinVMID()        Returns the virtual machine ID of a DOS box
*
*     WinSetFullScreen()  Forces a DOS box to full screen
*     WinSetClose()       Removes/adds the CLOSE command from a DOS box
*                         menu ( doesn't always work)
*
*     OpenClipboard()     Opens the clipboard for read/write operations
*     EmptyClipboard()    Empties the contents of the clipboard
*     SetClipboard()      Sets the contents of the clipboard (text only)
*     GetClipboard()      Returns the contents of the clipboard (text only)
*     CloseClipboard()    Closes the clipboard
*     GetClpSize()        Returns the size of the clipboard contents in bytes
*                         Clipboard must be open (text only)
*
*     WinGDIversion()     Returns version of GDI driver
*     WinGDIClassificat() Returns GDI driver classification
*                               0   Vector plotter
*                               1   Raster display (-default-)
*                               2   Raster printer
*                               3   Raster Camera
*                               4   Character Stream
*                               5   Metafile - VDM
*                               6   Display file
*
*     WinColors()         Returns number of colors in current GDI session
*     WinHeight()         Returns Height in pixels in current GDI session
*     WinWidth()          Returns Width in pixels in current GDI session
*     WinGDIfunc()        Returns misc. info about current GDI session
*/


#include "default.ch"
#include "ftint86.ch"

#xTranslate GDIGetWidthInPixels()   => WinGDIFunc(8)
#xTranslate GDIGetHeightInPixels()  => WinGDIFunc(10)
#xTranslate GDIGetMaxColors()       => WinGDIFunc(24)
#xTranslate GDIGetBitsPerPixel()    => WinGDIFunc(12)
#xTranslate GDIGetBitPlanes()       => WinGDIFunc(14)

#ifdef TEST
  
PROC TestWin()
LOCAL aVers := MsWinVersion()
cls
? "Running under Network ? :", IsNetwork()
? "Running under WINDOW$ ? :", IsMsWin()

IF IsMsWin() == .F.
   ? ""
   ? "NOT running under Window$."
   ? "Quiting"
   QUIT
ENDIF

? "Window$ Version         :", alltrim(str(aVers[1])), alltrim(str(aVers[2])), alltrim(str(aVers[3]))
? "Op Mode                 :", if( aVers[4] == 2, "Real", "Enhanced"), "Mode"
?
?
? "Resize this window to perform the next text."
? "Press any key to continue..."
inkey(0)
cls
? "Virtual Machine Name    :", GetWinVMName()
? "Application Name        :", GetWinAppName()
? "Change them..."
SetWinVMName("Window$ Suck...")
SetWinAppName(" - DOS Rules...")
? "Virtual Machine Name    :", GetWinVMName()
? "Application Name        :", GetWinAppName()
?
?
?
? "--------------------"
? "Clipboard functions"
? "--------------------"
? "Opened Clipboard ?      :", OpenClipboard()
SetClipboard( memoread("c:\autoexec.bat") )
? "Clipboard contains c:\autoexec.bat. Size: ", GetClpSize()
CloseClipboard()
? "Waiting for you to paste clipboard into some window$ app..."
? "Press any key"
inkey(0)
?
OpenClipboard()
SetClipboard( "CLIPPER Rules :)")
? "Copy 'CLIPPER Rules :)' to Clipboard"
? "Clipboard now contains [",GetClipboard(),"]"
CloseClipboard()
?
?
? "Press a key to set this DOS box in full screen"
inkey(0)
? "Success ??? :", WinSetFullScreen()
?
inkey(0)
?
? "--[ GDI ]---------------------------------------------"
? "GDI width & Height :", alltrim(str( winWidth() )),"x", alltrim(str(winHeight()))
? "GDI Version        :", alltrim(str( WinGDIVersion() ))
? "GDI classification :", alltrim(str( WinGDIClassification() )), "( 1 is screen )"
? "GDI Colors         :", alltrim(str( WinColors() )), "( doesn't always work properly )"
? "GDI Bits per pixel :", alltrim(str( GDIGetBitsPerPixel() ))
? "GDI Bit Planes     :", alltrim(str( GDIGetBitPlanes() ))
? "------------------------------------------------------"

RETURN

#endif


//
FUNCTION IsNetwork()
//
LOCAL aRegs[10]
aRegs[AX] := 0
FT_INT86( 42, aRegs )
RETURN( HighByte( aRegs[AX] ) <> 0 )



//
FUNCTION IsMsWin()
//
LOCAL aRegs[10]
aRegs[AX] := 5632                            // --> 1600h
FT_INT86( 47, aRegs )
RETURN( LowByte( aRegs[AX] ) <> 0 )

//
FUNCTION MsWinVersion()
//
LOCAL aRet[4]
LOCAL aRegs[10]
aRegs[AX] := 5642                            // --> 160Ah
FT_INT86( 47, aRegs )
if aRegs[AX] == 0
   aRet[1] := aRegs[BX]
   aRet[2] := highbyte(aRegs[BX])
   aRet[3] := lowbyte(aRegs[BX])
   aRet[4] := aRegs[CX]
endif
RETURN( aRet )

//
FUNCTION SetWinAppName( cName )              // Max 79 chars + NUL
//
LOCAL aRegs[10]
aRegs[AX]  := 5774                           // --> 168Eh
aRegs[DX]  := 0
aRegs[ES]  := alltrim(cName)+chr(0)
aRegs[DI]  := REG_ES
FT_INT86( 47, aRegs )
RETURN ( aRegs[AX] == 1 )


//
FUNCTION SetWinVMName( cName )               // max 29 chars + NUL
//
LOCAL aRegs[10]
aRegs[AX]  := 5774                           // --> 168Eh
aRegs[DX]  := 1
aRegs[ES]  := alltrim(cName)+chr(0)
aRegs[DI]  := REG_ES
FT_INT86( 47, aRegs )
RETURN ( aRegs[AX] == 1 )


//
FUNCTION GetWinAppName()
//
LOCAL aRegs[10]
aRegs[AX]  := 5774                           // --> 168Eh
aRegs[DX]  := 2
aRegs[ES]  := SPACE(79)
aRegs[DI]  := REG_ES
aRegs[CX]  := 79

FT_INT86( 47, aRegs )
RETURN( RTrim(aRegs[ES]) )


//
FUNCTION GetWinVMName()
//
LOCAL aRegs[10]
aRegs[AX]  := 5774                           // --> 168Eh
aRegs[DX]  := 3
aRegs[ES]  := SPACE(29)
aRegs[DI]  := REG_ES
aRegs[CX]  := 29

FT_INT86( 47, aRegs )
RETURN( RTrim(aRegs[ES]) )

//
FUNCTION GetWinVMId()                        // Get virtual machine ID
//
LOCAL aRegs[10]
aRegs[AX]  := 5763                           // --> 1683h

FT_INT86( 47, aRegs )
RETURN( aRegs[BX] )


//
FUNCTION OpenClipBoard()
//
LOCAL aRegs[10]
aRegs[AX]  := 5889                           // --> 1701h

FT_INT86( 47, aRegs )
RETURN ( aRegs[AX] <> 0 )


//
FUNCTION EmptyClipBoard()
//
LOCAL aRegs[10]
aRegs[AX]  := 5890                           // --> 1701h

FT_INT86( 47, aRegs )
RETURN ( aRegs[AX] <> 0 )


//
FUNCTION SetClipBoard( cData )
//
LOCAL aRegs[10]
aRegs[AX]  := 5891                           // --> 1703h
aRegs[DX]  := 1
aRegs[ES]  := cData
aRegs[BX]  := REG_ES
aRegs[SI]  := 0
aRegs[CX]  := len( cData )

FT_INT86( 47, aRegs )
RETURN ( aRegs[AX] <> 0 )


//
FUNCTION GetClipBoard()
//
LOCAL aRegs[10]
aRegs[AX]  := 5893                           // --> 1705h
aRegs[DX]  := 1                              // Text
aRegs[ES]  := SPACE( GetClpSize() )          // max 64000
aRegs[BX]  := REG_ES
FT_INT86( 47, aRegs )
RETURN ( RTrim( aRegs[ES] ) )



//
FUNCTION CloseClipBoard()
//
LOCAL aRegs[10]
aRegs[AX]  := 5896                           // --> 1708h
FT_INT86( 47, aRegs )
RETURN ( aRegs[AX] <> 0 )


//
FUNCTION GetClpSize()
//
LOCAL aRegs[10]
aRegs[AX]  := 5892                           // --> 1704h
aRegs[DX]  := 1
FT_INT86( 47, aRegs )
RETURN ( aRegs[AX]  )


//
FUNCTION WinSetFullScreen()
//
LOCAL aRegs[10]
aRegs[AX] := 5771                            //168Bh
aRegs[BX] := 0
FT_INT86( 47, aRegs )
RETURN (lowbyte( aRegs[AX] ) == 0)


//
FUNCTION WinSetClose( lOnOff )
//
LOCAL aRegs[10]
aRegs[AX] := 5775                            //168Fh
//aRegs[DX] := MAKEHI( 0 )+IF( lOnoff, 1, 0 )
aRegs[DX] := IF( lOnoff == .T., 1, 0 )
FT_INT86( 47, aRegs )
RETURN ( aRegs[AX] == 0)


/****
*
*        MsWindows GDI information
*
*/


//
FUNCTION WinGDIFunc( n )
//
LOCAL aRegs[10]
aRegs[AX] := 5898
aRegs[DX] := n
FT_INT86( 47, aRegs )
RETURN aRegs[AX]


//
FUNCTION WinGDIVersion()
//
LOCAL aRegs[10]
aRegs[AX] := 5898                            //170Ah
aRegs[DX] := 0
FT_INT86( 47, aRegs )
RETURN ( aRegs[AX] )


//
FUNCTION WinGDIClassification()
//
LOCAL aRegs[10]
aRegs[AX] := 5898                            //170Ah
aRegs[DX] := 2
FT_INT86( 47, aRegs )
RETURN ( aRegs[AX] )


//
FUNCTION WinColors()
//
LOCAL aRegs[10]
aRegs[AX] := 5898                            //170Ah
aRegs[DX] := 24
FT_INT86( 47, aRegs )
RETURN ( aRegs[AX] )


//
FUNCTION WinWidth()
//
LOCAL aRegs[10]
aRegs[AX] := 5898                            //170Ah
aRegs[DX] := 8
FT_INT86( 47, aRegs )
RETURN ( aRegs[AX] )


//
FUNCTION WinHeight()
//
LOCAL aRegs[10]
aRegs[AX] := 5898                            //170Ah
aRegs[DX] := 10
FT_INT86( 47, aRegs )
RETURN ( aRegs[AX] )

